// Fontx.cpp : 
//

#include <stdio.h>
#include <tchar.h>
#include <ctype.h>
#include <mbctype.h>
#include <mbstring.h>
//#include <memory.h>
#include <windows.h>
//#include <time.h>
//#include <locale.h>
#include "Fontx.h"

#define	FONT_FILE_ZEN_16_16		_T("_FONT\\MYRCZ16B.FNT")
#define FONT_FILE_HAN_8_16		_T("_FONT\\MYRCH16B.FNT")

#define FONT_FILE_ZEN_6_8		_T("_FONT\\K6X8X.FNT")

#define	FONT_FILE_ZEN_12_12		_T("_FONT\\DRUG12Z1.FEF")
#define	FONT_FILE_HAN_6_12		_T("_FONT\\DRUG12HN.FEF")

#define FONT_FILE_HAN_8_8		_T("_FONT\\TKFNT8H.FNT")
#define FONT_FILE_ZEN_8_8		_T("_FONT\\MISAKI.FNT")

#define OLED_WIDTH				128			// \̃hbg

//typedef struct _FontMetricsBlock {
//	unsigned short	StartCode;		// JnR[h(SJISR[h)
//	unsigned short	EndCode;		// IR[h(SJISR[h)
//	int				Num;			// R[h
//	BYTE			*FontData;		// tHgf[^
//} FONTMETRICSBLOCK;
//
//typedef struct _FontMetrics {
//	int		Width;		// tHg(dot)
//	int		Height;		// tHg(dot)
//	int		BytesWidth;			// tHgC[W̉oCg
//	int		BytesPerChar;		// 1oCg(tHgf[^)
//	int		BytesPerCharWrk;	// 1oCg(ϊ[Nf[^)
//	int		Code;		// R[h
//	int		Blocks;		// R[hubN
//	FONTMETRICSBLOCK	*Block;
//} FONTMETRICS;


//static FONTMETRICS		FontZen_16_16;
//static FONTMETRICS		FontHan_8_16;
//static FONTMETRICS		FontZen_6_8;
//static FONTMETRICS		FontHan_6_8;
//static FONTMETRICS		FontZen_12_12;
//static FONTMETRICS		FontHan_6_12;
//static FONTMETRICS		FontHan_8_8;
//static FONTMETRICS		FontZen_8_8;


void TransAxisBytes(BYTE *from, BYTE *to);
BYTE *GetFontData(FONTMETRICS *Font, unsigned short sjis_code);

/*
 *	tHgt@CǂݎAFONTMETRICSf[^쐬B
 */
BOOL GetFontMetrics(const TCHAR *FontFile, FONTMETRICS *FontMetrics){
	FILE	*fp;
	BYTE	buff[128];
	BYTE	work1[8], work[2];
	int		i, j, k;

//	if ((fp = _tfopen(FontFile, _T("rb"))) == NULL){
	if (_wfopen_s(&fp, FontFile, _T("rb")) != 0 || fp == NULL) {
			_tprintf(_T("tHgt@CI[vG[\n"));
		return FALSE;
	}
	fread(buff, 17, 1, fp);
	if (strncmp((char *)buff, "FONTX2", 6) != 0){
	//if (_tcsncmp((char *)buff, _T("FONTX2"), 6) != 0){
		_tprintf(_T("FONTXłȂ\n"));
		return FALSE;
	}
	FontMetrics->Width = buff[14];
	FontMetrics->Height = buff[15];
	FontMetrics->Code = buff[16];
	if (FontMetrics->Code == 0){	// ANK
		FontMetrics->Blocks = 1;
		FontMetrics->BytesWidth = 1;
		FontMetrics->BytesPerCharWrk = 16;
		FontMetrics->BytesPerChar = FontMetrics->BytesWidth * FontMetrics->Height;
		FontMetrics->Block = (FONTMETRICSBLOCK *)malloc(FontMetrics->Blocks * sizeof(FONTMETRICSBLOCK));

		i = 0;
		FontMetrics->Block[i].StartCode = 0;
		FontMetrics->Block[i].EndCode = 0xFF;
		FontMetrics->Block[i].Num = FontMetrics->Block[i].EndCode - FontMetrics->Block[i].StartCode + 1;
		FontMetrics->Block[i].FontData = (BYTE *)malloc(FontMetrics->Block[i].Num * FontMetrics->BytesPerCharWrk);

		for (j=0; j<FontMetrics->Block[i].Num; j++){
			fread(buff, FontMetrics->BytesPerChar, 1, fp);

			// ubN
			for (k=0; k<8; k++){
				work1[k] = buff[k];
			}
			TransAxisBytes(work1, FontMetrics->Block[i].FontData + (j * FontMetrics->BytesPerCharWrk));

			if (FontMetrics->Height > 8){
				// ubN
				for (k=0; k<8; k++){
					work1[k] = buff[k + 8];
				}
				TransAxisBytes(work1, FontMetrics->Block[i].FontData + (j * FontMetrics->BytesPerCharWrk) + 8);
			}
		}

	} else {
		fread(buff, 1, 1, fp);
		FontMetrics->Blocks = buff[0];
		FontMetrics->BytesWidth = ((FontMetrics->Width + 7) / 8);
		FontMetrics->BytesPerCharWrk = 32;	// 12x12, 16x16tHg(FontDataobt@̂PoCg)
		FontMetrics->BytesPerChar = FontMetrics->BytesWidth * FontMetrics->Height;
		FontMetrics->Block = (FONTMETRICSBLOCK *)malloc(FontMetrics->Blocks * sizeof(FONTMETRICSBLOCK));

		//_tprintf(_T("FontMetrics Width=%d\n"), FontMetrics->Width);
		//_tprintf(_T("FontMetrics BytesPerChar=%d\n"), FontMetrics->BytesPerChar);

		// R[hubNe[u
		for (i=0; i<FontMetrics->Blocks; i++){
			fread(buff, 4, 1, fp);

			FontMetrics->Block[i].StartCode = (buff[0] | ((unsigned short)buff[1] << 8));
			FontMetrics->Block[i].EndCode = (buff[2] | ((unsigned short)buff[3] << 8));
			FontMetrics->Block[i].Num = FontMetrics->Block[i].EndCode - FontMetrics->Block[i].StartCode + 1;
			FontMetrics->Block[i].FontData = (BYTE *)malloc(FontMetrics->Block[i].Num * FontMetrics->BytesPerCharWrk);
			//_tprintf(_T("FontMetrics StartCode=%d num=%d\n"), FontMetrics->Block[i].StartCode, FontMetrics->Block[i].Num);
		}

		// tHgC[W
		for (i=0; i<FontMetrics->Blocks; i++){
			for (j=0; j<FontMetrics->Block[i].Num; j++){
				fread(buff, FontMetrics->BytesPerChar, 1, fp);

				// 16x16tHgPubN=8x8hbĝSubNɕB
				// 
				// ABCDEFGH
				// IJKLMNOP
				// QRSTUVWX
				// abcdefgh
				// ijklmnop
				// qrstuvwx
				// 01234567
				// 
				// 
				// tHgt@Cł ABCDEFGH, IJKLMNOP, ... ŊeoCg\ĂB
				// 0qiaQIA, 1rjbRJB, ... ƂoCg\ɕϊB,,...ʃrbgƂȂB

				if (FontMetrics->BytesWidth == 2){
					// ubN
					for (k=0; k<8; k++){
						work1[k] = buff[2*k];
					}
					TransAxisBytes(work1, FontMetrics->Block[i].FontData + (j * FontMetrics->BytesPerCharWrk));
					// EubN
					for (k=0; k<8; k++){
						work1[k] = buff[2*k + 1];
					}
					TransAxisBytes(work1, FontMetrics->Block[i].FontData + (j * FontMetrics->BytesPerCharWrk) + 8);
					if (FontMetrics->Height > 8){
						// ubN
						for (k=0; k<8; k++){	//	12x12tHgł4
							work1[k] = buff[16 + 2*k];
						}
						TransAxisBytes(work1, FontMetrics->Block[i].FontData + (j * FontMetrics->BytesPerCharWrk) + 16);
						// EubN
						for (k=0; k<8; k++){	//	12x12tHgł4
							work1[k] = buff[16 + 2*k + 1];
						}
						TransAxisBytes(work1, FontMetrics->Block[i].FontData + (j * FontMetrics->BytesPerCharWrk) + 24);
					}
				} else if (FontMetrics->BytesWidth == 1){
					// ubN
					for (k=0; k<8; k++){
						work1[k] = buff[k];
					}
					TransAxisBytes(work1, FontMetrics->Block[i].FontData + (j * FontMetrics->BytesPerCharWrk));
					// ubN(?)
					if (FontMetrics->Height > 8){
						// KvɂȂ쐬
					}
				}

				//_tprintf(_T("FontMetrics i=%d j=%d\n"), i, j);
			}
		}
	}

	fclose(fp);

	return TRUE;
}

/*
 *	QoCgptHgf[^PoCgptHgf[^쐬B
 *	\[XƂȂQoCgtHg8x8ȉz肵ĂB
 */
BOOL MakeFontMetricsHan(FONTMETRICS *FontMetricsFrom, FONTMETRICS *FontMetrics){
	int		i;
	unsigned int c;
	unsigned int m;
	BYTE			*fontbyte;

	FontMetrics->Width = FontMetricsFrom->Width;
	FontMetrics->Height = FontMetricsFrom->Height;
	FontMetrics->Code = 0;

	FontMetrics->Blocks = 1;
	FontMetrics->BytesWidth = 1;
	FontMetrics->BytesPerCharWrk = 16;
	FontMetrics->BytesPerChar = FontMetrics->BytesWidth * FontMetrics->Height;
	FontMetrics->Block = (FONTMETRICSBLOCK *)malloc(FontMetrics->Blocks * sizeof(FONTMETRICSBLOCK));

	i = 0;
	FontMetrics->Block[i].StartCode = 0;
	FontMetrics->Block[i].EndCode = 0xFF;
	FontMetrics->Block[i].Num = FontMetrics->Block[i].EndCode - FontMetrics->Block[i].StartCode + 1;
	FontMetrics->Block[i].FontData = (BYTE *)malloc(FontMetrics->Block[i].Num * FontMetrics->BytesPerCharWrk);

	for (c=0; c<=0xFF; c++){
		if ((c >= 0x20 && c <= 0x7E) || (c >= 0xA1 && c<= 0xDF)){
			m = _mbbtombc(c);		// pɑΉSp(SJIS)
			//if (c <= 0x7E) printf("_mbbtombc %x -> %x\n", c, m);
		} else {
			m = 0x20;
		}
		fontbyte = GetFontData(FontMetricsFrom, m);
		if (fontbyte != NULL){
			memcpy(FontMetrics->Block[i].FontData + (c * FontMetrics->BytesPerCharWrk), fontbyte, FontMetrics->BytesPerCharWrk);
		} else {
			memset(FontMetrics->Block[i].FontData + (c * FontMetrics->BytesPerCharWrk), 0, FontMetrics->BytesPerCharWrk);
		}
	}

	return TRUE;
}


/*
 *	W̃oCgz̃rbgʒucւ
 */
void TransAxisBytes(BYTE *from, BYTE *to){
	int		i, j;

	for (i=0; i<8; i++) to[i] = 0;
	
	to[0] |= ((from[0] & 0x80) >> 7);
	to[1] |= ((from[0] & 0x40) >> 6);
	to[2] |= ((from[0] & 0x20) >> 5);
	to[3] |= ((from[0] & 0x10) >> 4);
	to[4] |= ((from[0] & 0x08) >> 3);
	to[5] |= ((from[0] & 0x04) >> 2);
	to[6] |= ((from[0] & 0x02) >> 1);
	to[7] |= ((from[0] & 0x01) >> 0);

	to[0] |= ((from[1] & 0x80) >> 6);
	to[1] |= ((from[1] & 0x40) >> 5);
	to[2] |= ((from[1] & 0x20) >> 4);
	to[3] |= ((from[1] & 0x10) >> 3);
	to[4] |= ((from[1] & 0x08) >> 2);
	to[5] |= ((from[1] & 0x04) >> 1);
	to[6] |= ((from[1] & 0x02) >> 0);
	to[7] |= ((from[1] & 0x01) << 1);

	to[0] |= ((from[2] & 0x80) >> 5);
	to[1] |= ((from[2] & 0x40) >> 4);
	to[2] |= ((from[2] & 0x20) >> 3);
	to[3] |= ((from[2] & 0x10) >> 2);
	to[4] |= ((from[2] & 0x08) >> 1);
	to[5] |= ((from[2] & 0x04) >> 0);
	to[6] |= ((from[2] & 0x02) << 1);
	to[7] |= ((from[2] & 0x01) << 2);

	to[0] |= ((from[3] & 0x80) >> 4);
	to[1] |= ((from[3] & 0x40) >> 3);
	to[2] |= ((from[3] & 0x20) >> 2);
	to[3] |= ((from[3] & 0x10) >> 1);
	to[4] |= ((from[3] & 0x08) >> 0);
	to[5] |= ((from[3] & 0x04) << 1);
	to[6] |= ((from[3] & 0x02) << 2);
	to[7] |= ((from[3] & 0x01) << 3);

	to[0] |= ((from[4] & 0x80) >> 3);
	to[1] |= ((from[4] & 0x40) >> 2);
	to[2] |= ((from[4] & 0x20) >> 1);
	to[3] |= ((from[4] & 0x10) >> 0);
	to[4] |= ((from[4] & 0x08) << 1);
	to[5] |= ((from[4] & 0x04) << 2);
	to[6] |= ((from[4] & 0x02) << 3);
	to[7] |= ((from[4] & 0x01) << 4);

	to[0] |= ((from[5] & 0x80) >> 2);
	to[1] |= ((from[5] & 0x40) >> 1);
	to[2] |= ((from[5] & 0x20) >> 0);
	to[3] |= ((from[5] & 0x10) << 1);
	to[4] |= ((from[5] & 0x08) << 2);
	to[5] |= ((from[5] & 0x04) << 3);
	to[6] |= ((from[5] & 0x02) << 4);
	to[7] |= ((from[5] & 0x01) << 5);

	to[0] |= ((from[6] & 0x80) >> 1);
	to[1] |= ((from[6] & 0x40) >> 0);
	to[2] |= ((from[6] & 0x20) << 1);
	to[3] |= ((from[6] & 0x10) << 2);
	to[4] |= ((from[6] & 0x08) << 3);
	to[5] |= ((from[6] & 0x04) << 4);
	to[6] |= ((from[6] & 0x02) << 5);
	to[7] |= ((from[6] & 0x01) << 6);

	to[0] |= ((from[7] & 0x80) >> 0);
	to[1] |= ((from[7] & 0x40) << 1);
	to[2] |= ((from[7] & 0x20) << 2);
	to[3] |= ((from[7] & 0x10) << 3);
	to[4] |= ((from[7] & 0x08) << 4);
	to[5] |= ((from[7] & 0x04) << 5);
	to[6] |= ((from[7] & 0x02) << 6);
	to[7] |= ((from[7] & 0x01) << 7);

}

/*
 *	PUXPUtHg̏ꍇAAEAAȄłꂼWoCgB
 */
BYTE *GetFontData(FONTMETRICS *Font, unsigned short sjis_code){
	int		i;

	for (i=0; i<Font->Blocks; i++){
		//_tprintf(_T("GetFontData i=%d\n"), i);
		if (sjis_code >= Font->Block[i].StartCode && sjis_code <= Font->Block[i].EndCode){
			//_tprintf(_T(" GetFontData (%d,%d)\n"), Font->Block[i].StartCode, Font->Block[i].EndCode);
			return (Font->Block[i].FontData + (sjis_code - Font->Block[i].StartCode) * Font->BytesPerCharWrk);
		}
	}

	return NULL;
}


//BOOL InitFont(){
//	if (GetFontMetrics(FONT_FILE_ZEN_16_16, &FontZen_16_16) == FALSE){
//		_tprintf(_T("GetFontMetrics error %s\n"), FONT_FILE_ZEN_16_16);
//		return FALSE;
//	}
//	if (GetFontMetrics(FONT_FILE_HAN_8_16, &FontHan_8_16) == FALSE){
//		_tprintf(_T("GetFontMetrics error %s\n"), FONT_FILE_HAN_8_16);
//		return FALSE;
//	}
//	if (GetFontMetrics(FONT_FILE_ZEN_6_8, &FontZen_6_8) == FALSE){
//		_tprintf(_T("GetFontMetrics error %s\n"), FONT_FILE_ZEN_6_8);
//		return FALSE;
//	}
//	MakeFontMetricsHan(&FontZen_6_8, &FontHan_6_8);
//
//	if (GetFontMetrics(FONT_FILE_ZEN_12_12, &FontZen_12_12) == FALSE){
//		_tprintf(_T("GetFontMetrics error %s\n"), FONT_FILE_ZEN_12_12);
//		return FALSE;
//	}
//	if (GetFontMetrics(FONT_FILE_HAN_6_12, &FontHan_6_12) == FALSE){
//		_tprintf(_T("GetFontMetrics error %s\n"), FONT_FILE_HAN_6_12);
//		return FALSE;
//	}
//	if (GetFontMetrics(FONT_FILE_HAN_8_8, &FontHan_8_8) == FALSE){
//		_tprintf(_T("GetFontMetrics error %s\n"), FONT_FILE_HAN_8_8);
//		return FALSE;
//	}
//	if (GetFontMetrics(FONT_FILE_ZEN_8_8, &FontZen_8_8) == FALSE){
//		_tprintf(_T("GetFontMetrics error %s\n"), FONT_FILE_ZEN_8_8);
//		return FALSE;
//	}
//	return TRUE;
//}

/*
 *	SJISsjis_strLCDC[W쐬BPUhbgtHgO񂵁A㔼line0ɁAline1ɍ쐬B
 */
void MakeLcdDataOfString(BYTE* line0, int size0, BYTE* line1, int size1, unsigned char* sjis_str, int str_length, FONTMETRICS* pfhan, FONTMETRICS* pfzen) {
	int				i, j;
	int				x;
	unsigned short	sjis_char;
	BYTE* fontbyte;
	
	x = 0;

	for (i = 0; i < str_length; i++) {
		//_tprintf(_T(" MakeLcdDataOfString i=%d \n"), i);
		if (_ismbslead((unsigned char*)sjis_str, (unsigned char*)(sjis_str + i)) != 0) {		// QoCg
			sjis_char = ((sjis_str[i] << 8) | sjis_str[i + 1]);
			//_tprintf(_T(" sjis_char(Z) =%d \n"), sjis_char);
			fontbyte = GetFontData(pfzen, sjis_char);
			if (fontbyte != NULL) {
				// QoCgOLED̍sɎ܂ȂƂ󔒂}AQoCg̕\̍sɐi߂
				if (x < OLED_WIDTH && (x + pfzen->Width) >= OLED_WIDTH) {
					for (; x < OLED_WIDTH; x++) {
						if (x == size0 || x == size1) break;
						line0[x] = 0;
						line1[x] = 0;
					}
				}
				else if (x < (2*OLED_WIDTH) && (x + pfzen->Width) >= (2*OLED_WIDTH)) {
					for (; x < (2*OLED_WIDTH); x++) {
						if (x == size0 || x == size1) break;
						line0[x] = 0;
						line1[x] = 0;
					}
				}
				else if (x < (3*OLED_WIDTH) && (x + pfzen->Width) >= (3*OLED_WIDTH)) {
					for (; x < (3*OLED_WIDTH); x++) {
						if (x == size0 || x == size1) break;
						line0[x] = 0;
						line1[x] = 0;
					}
				}

				for (j = 0; j < pfzen->Width; j++) {
					if (x == size0 || x == size1) break;
					line0[x] = *(fontbyte + j);
					line1[x] = *(fontbyte + 16 + j);
					x++;
					//if (x == size0 || x == size1) break;
				}
			}
			else {
				_tprintf(_T(" SptHgf[^Ȃ (%d,%x)\n"), i, sjis_char);
			}
			i++;
		}
		else {
			//_tprintf(_T(" sjis_char(H) =%d \n"), sjis_str[i]);
			fontbyte = GetFontData(pfhan, sjis_str[i]);
			if (fontbyte != NULL) {
				for (j = 0; j < pfhan->Width; j++) {
					line0[x] = *(fontbyte + j);
					if (pfhan->Height > 8) {
						line1[x] = *(fontbyte + 8 + j);
					}
					else {
						line1[x] = 0;
					}
					x++;
					if (x == size0 || x == size1) break;
				}
			}
			else {
				_tprintf(_T(" ptHgf[^Ȃ (%d:%c)\n"), i, sjis_str[i]);
			}
		}

		if (x == size0 || x == size1) break;
	}

}

#if 0
/*
 *	yMP3_08/09zsjis_str(str_length:SJISZ)OLED\f[^쐬B
 *		line0, line1 : Ps\̏ꍇAꂼOLED̏㔼Aɕ\f[^A
 *					 : Qs\̏ꍇAׂĂ̕\f[^line0ɍ쐬Bline1͖gpB
 *		size0, size1 : line0/line1̃obt@TCY
 *		*width : line0/line1ɍ쐬ꂽhbg
 *		*Scroll : \X^C (0:Ps\XN[ȂA1:Ps\XN[A2:Qs\XN[ȂA3:Qs\XN[)
 */
void MakeOLEDdataOfString(BYTE *line0, int size0, BYTE *line1, int size1, unsigned char *sjis_str, int str_length, int *width, int *Scroll){
	int				i, j;
	int				x;
	unsigned short	sjis_char;
	BYTE			*fontbyte;
	BOOLEAN			HasZen;
	int				lines;
	FONTMETRICS		*pfzen;
	FONTMETRICS		*pfhan;
	int				line;
	int				shiftbit;		// Ps\Ƃ㉺ԂƂȂ悤ɃrbgVtg
	BYTE			mask;

	_tprintf(_T("MakeOLEDdataOfString:[%s][%d]\n"), sjis_str, str_length);

	// QoCg܂ނH
	HasZen = FALSE;
	for (i=0; i<str_length; i++){
		if (_ismbslead((unsigned char *)sjis_str, (unsigned char *)(sjis_str + i)) != 0){
			HasZen = TRUE;
			break;
		}
	}

	/*
	 * tHgX^C胍WbN
	 */
	if (str_length <= 12){
		pfzen = &FontZen_16_16;
		pfhan = &FontHan_8_16;
		*Scroll = 0;
		lines = 1;
		shiftbit = 0;
		mask = 0xFF;
		//_tprintf(_T("FontZen_16_16 FontHan_8_16 "));
	} else if (str_length <= 16){
		pfzen = &FontZen_12_12;
		pfhan = &FontHan_6_12;
		*Scroll = 0;
		lines = 1;
		shiftbit = 2;
		mask = 0x0F;
	} else if (HasZen == FALSE){	// QoCg܂܂Ȃ
		pfzen = NULL;
		if (str_length <= 24){
			pfhan = &FontHan_8_8;
			if (str_length <= 12){	// WhbgtHgłPs\
				lines = 1;
				shiftbit = 4;
				*Scroll = 0;
			} else {				// WhbgtHgłQs\
				lines = 2;
				shiftbit = 0;
				*Scroll = 2;
			}
		} else {					// WhbgtHgłQs\
			pfhan = &FontHan_6_8;
			lines = 2;
			shiftbit = 0;
			*Scroll = 3;
		}
		mask = 0xFF;
	} else {		// 12hbgtHgłPs\BXN[
		pfzen = &FontZen_12_12;
		pfhan = &FontHan_6_12;
		*Scroll = 1;
		lines = 1;
		shiftbit = 2;
		mask = 0x0F;
		//_tprintf(_T("FontZen_12_12 FontHan_6_12 "));
	}

	x = 0;

	if (lines == 1){
		for (i=0; i<str_length; i++){
			if (_ismbslead((unsigned char *)sjis_str, (unsigned char *)(sjis_str + i)) != 0){
				sjis_char = ((sjis_str[i] << 8) | sjis_str[i+1]);
				fontbyte = GetFontData(pfzen, sjis_char);
				if (fontbyte != NULL){
					for (j=0; j<pfzen->Width; j++){
						line0[x] = *(fontbyte + j);
						line1[x] = (*(fontbyte + 16 + j) & mask);
						if (shiftbit > 0){
							line1[x] = ((line1[x] << shiftbit) | (line0[x] >> (8 - shiftbit)));
							line0[x] <<= shiftbit;
						}
						x++;
						if (x == size0 || x == size1) break;
					}
				} else {
					_tprintf(_T(" SptHgf[^Ȃ (%d,%x)\n"), i, sjis_char);
				}
				i++;
			} else {
				fontbyte = GetFontData(pfhan, sjis_str[i]);
				if (fontbyte != NULL){
					for (j=0; j<pfhan->Width; j++){
						line0[x] = *(fontbyte + j);
						if (pfhan->Height > 8){
							line1[x] = (*(fontbyte + 8 + j) & mask);
						} else {
							line1[x] = 0;
						}
						if (shiftbit > 0){
							line1[x] = ((line1[x] << shiftbit) | (line0[x] >> (8 - shiftbit)));
							line0[x] <<= shiftbit;
						}
						x++;
						if (x == size0 || x == size1) break;
					}
				} else {
					_tprintf(_T(" ptHgf[^Ȃ (%d:%c)\n"), i, sjis_str[i]);
				}
			}

			if (x == size0 || x == size1) break;
		}

		// E[̎c
		for (i=x; i<OLED_WIDTH; i++){
			line0[i] = 0;
			line1[i] = 0;
		}

		*width = x;
		if (*width < OLED_WIDTH) *width = OLED_WIDTH;
	} else {	// Qs\iׂĔpOj
		line = 0;
		for (i=0; i<str_length; i++){
#if 0
			if (line == 0 && (x + pfhan->Width) > OLED_WIDTH){
				line = 1;
				x = 0;
			} else if (line == 1 && (x + pfhan->Width) > OLED_WIDTH) break;
#endif
			if ((x + pfhan->Width) > size0) break;
			fontbyte = GetFontData(pfhan, sjis_str[i]);
			if (fontbyte != NULL){
				for (j=0; j<pfhan->Width; j++){
					if (line == 0){
						line0[x] = *(fontbyte + j);
					} else {
						line1[x] = *(fontbyte + j);
					}
					x++;
					if (x == size0 || x == size1) break;
				}
			} else {
				_tprintf(_T(" ptHgf[^Ȃ (%d:%c)\n"), i, sjis_str[i]);
			}

			if (x == size0 || x == size1) break;
		}

//		*width = OLED_WIDTH;
		*width = x;

		// E[̎c
		for (i=x; i<size0; i++){
			line0[i] = 0;
		}
		for (i=0; i<size1; i++){
			line1[i] = 0;
		}
	}

	_tprintf(_T(" C[W=%d\n"), *width);

}

/*
 *	yMP3_10zsjis_str(str_length:SJISZ)LCD\f[^쐬B
 *		PoCg^QoCgƂɍ12hbg̃tHggB
 *		PPsline_lengthhbgAőQsŕ\B
 *		Psڂline0line1̉ʂSrbgɁAQsڂline1̏ʂSrbgline2ɃZbgB(line0/1/2͍Œline_lengthoCg)
 */
int MakeLcdDataOfString_10(BYTE *line0, BYTE *line1, BYTE *line2, int line_length, unsigned char *sjis_str){
	int				i, j;
	int				x;
	FONTMETRICS		*pfzen;
	FONTMETRICS		*pfhan;
	unsigned short	sjis_char;
	BYTE			*fontbyte;
	BYTE			mask;
	int				str_length;
	int				line;

	str_length = _tcslen((char *)sjis_str);

	memset(line0, 0, line_length);
	memset(line1, 0, line_length);
	memset(line2, 0, line_length);

	pfhan = &FontHan_6_12;
	pfzen = &FontZen_12_12;
	mask = 0x0F;

	line = 0;
	x = 0;

	for (i=0; i<str_length; i++){
		if (_ismbslead((unsigned char *)sjis_str, (unsigned char *)(sjis_str + i)) != 0){
			sjis_char = ((sjis_str[i] << 8) | sjis_str[i+1]);
			fontbyte = GetFontData(pfzen, sjis_char);
			if (fontbyte != NULL){
				if ((x + pfzen->Width) > line_length){
					if (line == 0){
						line = 1;
						x = 0;
					} else break;
				}
				for (j=0; j<pfzen->Width; j++){
					if (line == 0){
						line0[x] = *(fontbyte + j);
						line1[x] = (*(fontbyte + 16 + j) & mask);
					} else {
						line1[x] |= ((*(fontbyte + j) & mask) << 4);
						line2[x] = (*(fontbyte + j) & ~mask) >> 4;
						line2[x] |= ((*(fontbyte + 16 + j) & mask) << 4);
					}
					x++;
				}
			}
			i++;
		} else {
			fontbyte = GetFontData(pfhan, sjis_str[i]);
			if (fontbyte != NULL){
				if ((x + pfzen->Width) > line_length){
					if (line == 0){
						line = 1;
						x = 0;
					} else break;
				}
				for (j=0; j<pfhan->Width; j++){
					if (line == 0){
						line0[x] = *(fontbyte + j);
						line1[x] = (*(fontbyte + 8 + j) & mask);
					} else {
						line1[x] |= ((*(fontbyte + j) & mask) << 4);
						line2[x] = (*(fontbyte + j) & ~mask) >> 4;
						line2[x] |= ((*(fontbyte + 8 + j) & mask) << 4);
					}
					x++;
				}
			}
		}

	}
			
	return x;
}

/*
 *	j[ڗpOLEDC[W쐬BSpEp킸AWhbg̃tHgŕ\B
 *	C[W̃hbgsize0Ŏw肵A蒷Ƃ͐؂̂Ă(̓rłĂ)B
 *	܂AZƂ͂OŖ߂B
 *	MP3_09pB
 */
void MakeOLEDdataShortMenu(BYTE *line0, int size0, unsigned char *sjis_str, int str_length){
	int				i, j;
	int				x;
	BOOLEAN			HasZen;
	FONTMETRICS		*pfzen;
	FONTMETRICS		*pfhan;
	unsigned short	sjis_char;
	BYTE			*fontbyte;

	// QoCg܂ނH
	HasZen = FALSE;
	for (i=0; i<str_length; i++){
		if (_ismbslead((unsigned char *)sjis_str, (unsigned char *)(sjis_str + i)) != 0){
			HasZen = TRUE;
			break;
		}
	}

	pfhan = &FontHan_6_8;
	pfzen = &FontZen_8_8;

	x = 0;

	for (i=0; i<str_length; i++){
		if (_ismbslead((unsigned char *)sjis_str, (unsigned char *)(sjis_str + i)) != 0){
			sjis_char = ((sjis_str[i] << 8) | sjis_str[i+1]);
			fontbyte = GetFontData(pfzen, sjis_char);
			if (fontbyte != NULL){
				for (j=0; j<pfzen->Width; j++){
					line0[x] = *(fontbyte + j);
					x++;
					if (x == size0) break;
				}
			}
			i++;
		} else {
			fontbyte = GetFontData(pfhan, sjis_str[i]);
			if (fontbyte != NULL){
				for (j=0; j<pfhan->Width; j++){
					line0[x] = *(fontbyte + j);
					x++;
					if (x == size0) break;
				}
			}
		}

		if (x == size0) break;
	}
			
	// E[̎c
	for (i=x; i<size0; i++){
		line0[i] = 0;
	}
}


/*
 *	j[ڗpOLEDC[W쐬BSpEp킸AWhbg̃tHgŕ\B
 *	C[W̃hbgwidthŎw肵A蒷Ƃ͐؂̂Ă(̓rłĂ)B
 *	܂AZƂ͂OŖ߂B
 */
void MakeOLEDdataOfMenu(BYTE *line, int width, unsigned char *sjis_str, int str_length){
	int				i, j;
	int				x;
	unsigned short	sjis_char;
	BYTE			*fontbyte;
	FONTMETRICS		*pfzen;
	FONTMETRICS		*pfhan;

	pfzen = &FontZen_8_8;
	pfhan = &FontHan_6_8;

	x = 0;

	for (i=0; i<str_length; i++){
		if (_ismbslead((unsigned char *)sjis_str, (unsigned char *)(sjis_str + i)) != 0){
			sjis_char = ((sjis_str[i] << 8) | sjis_str[i+1]);
			fontbyte = GetFontData(pfzen, sjis_char);
			if (fontbyte != NULL){
				for (j=0; j<pfzen->Width; j++){
					line[x] = *(fontbyte + j);
					x++;
					if (x == width) break;
				}
			} else {
				_tprintf(_T(" SptHgf[^Ȃ (%d,%x)\n"), i, sjis_char);
			}
			i++;
		} else {
			fontbyte = GetFontData(pfhan, sjis_str[i]);
			if (fontbyte != NULL){
				for (j=0; j<pfhan->Width; j++){
					line[x] = *(fontbyte + j);
					x++;
					if (x == width) break;
				}
			} else {
				_tprintf(_T(" ptHgf[^Ȃ (%d:%c)\n"), i, sjis_str[i]);
			}
		}
	}

	// E[̎c
	for (i=x; i<width; i++){
		line[i] = 0;
	}
}


/*
 *	Œ胁bZ[WpOLED\f[^
 *	bZ[W͔p̂ݑΉB
 */
void MakeOLEDdataOfMessage(BYTE *line0, int size0, unsigned char *sjis_str, int *width){
	FONTMETRICS		*pfhan;
	int				str_length;
	int				i;
	int				j;
	int				x;
	BYTE			*fontbyte;

	pfhan = &FontHan_6_8;
	str_length = _tcslen((char *)sjis_str);
	x = 0;

	for (i=0; i<str_length; i++){
		fontbyte = GetFontData(pfhan, sjis_str[i]);
		if (fontbyte != NULL){
			for (j=0; j<pfhan->Width; j++){
				line0[x] = *(fontbyte + j);
				x++;
				if (x == size0) break;
			}
		} else {
			_tprintf(_T(" ptHgf[^Ȃ (%d:%c)\n"), i, sjis_str[i]);
		}
	}

	*width = x;
}
#endif
